/* firmware_wrapper.c -- Wrappers for firmware dependent functions
 *
 * Copyright (C) 2021 Reiko Asakura
 *
 * This software may be modified and distributed under the terms
 * of the MIT license.  See the LICENSE file for details.
 */
#include <kernel/cpu.h>
#include <kernel/modulemgr.h>
#include <kernel/sysmem.h>

void sceKernelCpuDcacheWritebackInvalidateRange_365();
void sceKernelCpuIcacheAndL2WritebackInvalidateRange_365();
int sceKernelGetModuleInfo_365();
int sceKernelGetModuleInternal_365();
int sceKernelGetModuleList_365();
int sceKernelStopModuleForPid_365();
int sceKernelUnloadModuleForPid_365();
SceUID sceKernelCreateUidObj_365();
int sceKernelRxMemcpyKernelToUserForPid_365();

void __real_sceKernelCpuDcacheWritebackInvalidateRange();
void __real_sceKernelCpuIcacheAndL2WritebackInvalidateRange();
int __real_sceKernelGetModuleInfo();
int __real_sceKernelGetModuleInternal();
int __real_sceKernelGetModuleList();
int __real_sceKernelStopModuleForPid();
int __real_sceKernelUnloadModuleForPid();
SceUID __real_sceKernelCreateUidObj();
int __real_sceKernelRxMemcpyKernelToUserForPid();

#define IS_RESOLVED(fptr) (*(int*)fptr != 0xE24FC008)

#define DISPATCH(f, ...) do { \
  if (IS_RESOLVED(__real_##f)) { \
    return __real_##f(__VA_ARGS__); \
  } else { \
    return f##_365(__VA_ARGS__); \
  } \
} while (0)

void __wrap_sceKernelCpuDcacheWritebackInvalidateRange(const void *ptr, SceSize len) {
  DISPATCH(sceKernelCpuDcacheWritebackInvalidateRange, ptr, len);
}

void __wrap_sceKernelCpuIcacheAndL2WritebackInvalidateRange(const void *ptr, SceSize len) {
  DISPATCH(sceKernelCpuIcacheAndL2WritebackInvalidateRange, ptr, len);
}

int __wrap_sceKernelGetModuleInfo(SceUID pid, SceUID modid, SceKernelModuleInfo *info) {
  DISPATCH(sceKernelGetModuleInfo, pid, modid, info);
}

int __wrap_sceKernelGetModuleInternal(SceUID modid, void **info) {
  DISPATCH(sceKernelGetModuleInternal, modid, info);
}

int __wrap_sceKernelGetModuleList(SceUID pid, int flags1, int flags2, SceUID *modids, SceSize *num) {
  DISPATCH(sceKernelGetModuleList, pid, flags1, flags2, modids, num);
}

int __wrap_sceKernelStopModuleForPid(SceUID pid, SceUID modid, SceSize args, void *argp, int flags, SceKernelStopModuleOpt *option, int *status) {
  DISPATCH(sceKernelStopModuleForPid, pid, modid, args, argp, flags, option, status);
}

int __wrap_sceKernelUnloadModuleForPid(SceUID pid, SceUID modid, int flags, SceKernelUnloadModuleOpt *option) {
  DISPATCH(sceKernelUnloadModuleForPid, pid, modid, flags, option);
}

SceUID __wrap_sceKernelCreateUidObj(SceClass *cls, const char *name, SceCreateUidObjOpt *opt, SceObjectBase **obj) {
  DISPATCH(sceKernelCreateUidObj, cls, name, opt, obj);
}

int __wrap_sceKernelRxMemcpyKernelToUserForPid(SceUID pid, uintptr_t dst, const void *src, SceSize len) {
  DISPATCH(sceKernelRxMemcpyKernelToUserForPid, pid, dst, src, len);
}
